Package org.apache.uima.collection.metadata

# Interface CpeCasProcessors

All Superinterfaces:
  `Cloneable`, `MetaDataObject`, `Serializable`, `XMLizable`

public interface CpeCasProcessors extends MetaDataObject
An object that holds configuration that is part of the CPE descriptor. It provides the means of configuring the CPE Processing Pipeline and to tweak performance charactristics of the CPE. It contains a list of CasProcessors that will be strung together into a pipeline by the CPE.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addCpeCasProcessor(CpeCasProcessor aCasProcessor)`
  Appends new CasProcessor to existing list of CasProcessors
  `void`
  `addCpeCasProcessor(CpeCasProcessor aCasProcessor, int aInsertPosition)`
  Inserts a new CasProcessor at an indicated position.
  `CpeCasProcessor[]`
  `getAllCpeCasProcessors()`
  Returns ALL `CpeCasProcessor` objects in processing pipeline.
  `int`
  `getCasPoolSize()`
  `int`
  `getConcurrentPUCount()`
  Returns number of ProcessingUnits.
  `CpeCasProcessor`
  `getCpeCasProcessor(int aPosition)`
  Returns `CpeCasProcessor` found at given position.
  `boolean`
  `getDropCasOnException()`
  `int`
  `getInputQueueSize()`
  Returns size of the InputQueue.
  `int`
  `getOutputQueueSize()`
  Returns the size of the OutputQueue.
  `void`
  `removeAllCpeCasProcessors()`
  Removes ALL `CpeCasProcessor` objects from processing pipeline.
  `void`
  `removeCpeCasProcessor(int aPosition)`
  Removes `CpeCasProcessor` object from processing pipeline from a given position.
  `void`
  `setConcurrentPUCount(int aConcurrentPUCount)`
  Sets ProcessingUnit replication.
  `void`
  `setInputQueueSize(int aOutputQueueSize)`
  Sets the size of the InputQueue.
  `void`
  `setOutputQueueSize(int aOutputQueueSize)`
  Sets the size of the OutputQueue.
  `void`
  `setPoolSize(int aPoolSize)`

  ### Methods inherited from interface org.apache.uima.resource.metadata.MetaDataObject

  `clone, equals, getAttributeValue, getSourceUrl, getSourceUrlString, isModifiable, listAttributes, setAttributeValue, setSourceUrl`

  ### Methods inherited from interface org.apache.uima.util.XMLizable

  `buildFromXMLElement, buildFromXMLElement, toXML, toXML, toXML, toXML`

- ## Method Details

  - ### setOutputQueueSize

    void setOutputQueueSize(int aOutputQueueSize) throws CpeDescriptorException
    Sets the size of the OutputQueue. This queue is shared among Processing Units and CasConsumers and contains bundles of CAS. Processing Units add bundles to the queue while CasConsumers consume them. The best size for this queue is determined by overall performance of the ProcessingUnit ( how fast it deposits bundles onto the queue) and memory availability. The larger the queue the more bundles (hence memory) is used.
    Parameters:
      `aOutputQueueSize` - - Output queue size
    Throws:
      `CpeDescriptorException` - tbd

  - ### getOutputQueueSize

    int getOutputQueueSize()
    Returns the size of the OutputQueue. This queue is shared among Processing Units and CasConsumers and contains bundles of CAS. Processing Units add bundles to the queue while CasConsumers consume them. The best size for this queue is determined by overall performance of the ProcessingUnit ( how fast it deposits bundles onto the queue) and memory availability. The larger the queue the more bundles (hence memory) is used.
    Returns:
      - output queue size

  - ### setInputQueueSize

    void setInputQueueSize(int aOutputQueueSize) throws CpeDescriptorException
    Sets the size of the InputQueue. This queue is shared among CollectionReader and Processing Units and contains bundles of CAS. CollectionReader adds bundles to the queue while Processing Unit consume them. The best size for this queue is determined by overall performance of the ProcessingUnit ( how fast it takes bundles off the queue) and memory availability. The larger the queue the more bundles (hence memory) is used.
    Parameters:
      `aOutputQueueSize` - - queue size
    Throws:
      `CpeDescriptorException` - tbd

  - ### getInputQueueSize

    int getInputQueueSize()
    Returns size of the InputQueue. This queue is shared among CollectionReader and Processing Units and contains bundles of CAS. CollectionReader adds bundles to the queue while Processing Unit consume them. The best size for this queue is determined by overall performance of the ProcessingUnit ( how fast it takes bundles off the queue) and memory availability. The larger the queue the more bundles (hence memory) is used.
    Returns:
      - queue size

  - ### setConcurrentPUCount

    void setConcurrentPUCount(int aConcurrentPUCount) throws CpeDescriptorException
    Sets ProcessingUnit replication. Each ProcessingUnit contains the same sequence of CasProcessors and runs in a seperate thread. On platforms containing more than one CPU, replicating ProcessingUnit may result in better performance.
    Parameters:
      `aConcurrentPUCount` - - number of ProcessingUnits(processing threads)
    Throws:
      `CpeDescriptorException` - tbd

  - ### getConcurrentPUCount

    int getConcurrentPUCount()
    Returns number of ProcessingUnits. Each ProcessingUnit contains the same sequence of CasProcessors and runs in a seperate thread. On platforms containing more than one CPU, replicating ProcessingUnit may result in better performance.
    Returns:
      - number of ProcessingUnits(processing threads)

  - ### addCpeCasProcessor

    void addCpeCasProcessor(CpeCasProcessor aCasProcessor, int aInsertPosition) throws CpeDescriptorException
    Inserts a new CasProcessor at an indicated position.
    Parameters:
      `aCasProcessor` - - CasProcessor to add
      `aInsertPosition` - - position where to insert the CasProcessor
    Throws:
      `CpeDescriptorException` - tbd

  - ### addCpeCasProcessor

    void addCpeCasProcessor(CpeCasProcessor aCasProcessor) throws CpeDescriptorException
    Appends new CasProcessor to existing list of CasProcessors
    Parameters:
      `aCasProcessor` - - CasProcessor to add
    Throws:
      `CpeDescriptorException` - tbd

  - ### getCpeCasProcessor

    CpeCasProcessor getCpeCasProcessor(int aPosition) throws CpeDescriptorException
    Returns `CpeCasProcessor` found at given position.
    Parameters:
      `aPosition` - - position of the CasProcessor
    Returns:
      - `CpeCasProcessor`
    Throws:
      `CpeDescriptorException` - tbd

  - ### getAllCpeCasProcessors

    CpeCasProcessor[] getAllCpeCasProcessors() throws CpeDescriptorException
    Returns ALL `CpeCasProcessor` objects in processing pipeline.
    Returns:
      array of `CpeCasProcessor`
    Throws:
      `CpeDescriptorException` - tbd

  - ### removeCpeCasProcessor

    void removeCpeCasProcessor(int aPosition) throws CpeDescriptorException
    Removes `CpeCasProcessor` object from processing pipeline from a given position.
    Parameters:
      `aPosition` - - position of the CasProcessor in the pipeline
    Throws:
      `CpeDescriptorException` - tbd

  - ### removeAllCpeCasProcessors

    void removeAllCpeCasProcessors() throws CpeDescriptorException
    Removes ALL `CpeCasProcessor` objects from processing pipeline.
    Throws:
      `CpeDescriptorException` - tbd

  - ### setPoolSize

    void setPoolSize(int aPoolSize) throws CpeDescriptorException
    Throws:
      `CpeDescriptorException`

  - ### getCasPoolSize

    int getCasPoolSize()

  - ### getDropCasOnException

    boolean getDropCasOnException()